.hpf hyphen.local
.P1
.de PT
.tl 'CONF01 - CONFIGURATION TABLE'\*[CH]'PD-1C301-01'
.tl 'File: conf.c''Section 4'
.tl '''Issue 1, January 1976'
..
.2C
.sp 1n
.
.LP
.I CALL
.
.LP
none
.sp 1n
.
.LP
.I RETURNS
.
.LP
none
.ne 4
.sp 1n
.
.LP
.I SYNOPSIS
.
.LP
Character Device Switch Table and Block Device Switch Table. Also contains
definition of the root device and the swap device.
.ne 4
.sp 1n
.
.LP
.I DESCRIPTION
.
.LP
UNIX divides devices on the system into two classes; character devices and
block devices. The distinction is basically between devices that are byte
oriented and those that are oriented to transferring larger groups of data.
As such, there are two different tables which are used to select the proper
device. The Character Device Switch Table ("cdevsw") contains five entries
for each device. These are the open ("d_open"), close ("d_close"), read
("d_read"), write ("d_write") and sgtty ("d_sgtty") entries. These entries
are invoked when opening, closing, reading, writing or setting the modes
for a character device. The Block Device Switch Table has a similar formal
Here there is an open ("d_open"), close ("d_close"), strategy
("d_strategy") and device queue ("d_tab") entry. These are the open, and
close routines for the device, the strategy routine for reading and writing
the device and the device queue entry. Each table has a specific order in
which devices may appear. The order is listed in the file and any device
not listed may be added to the end of the table. A block device may have
entries in both tables. In this case, the entries in the Character Device
Table are used for physical I/O. Entries in the tables for which it is an
error to reference the entry are filled in with the trap.c/nosys function,
while entries which should produce no error are filled in by
trap.c/nullsys.
.
.LP
There are four other variables in this file which allow the specification
of the root filesystem and the swap device.
.
.LP
"rootdev" - This is the major and minor device number of the root
filesystem. The high order byte contains the major device number and the
low order byte contains the minor device number.
.
.LP
"swapdev" - This is the major and minor device number of the swap device.
.
.LP
"swplo" - This is the offset in 512 byte disk blocks into the swap device
that the swap area begins. This entry is present so that the root
filesystem and the swap device may be on the same minor device. This number
may not ever be 0.
.
.LP
"nswap" - This is the number of 512 byte disk blocks allocated to the swap
area.
